// database.cpp

#include "data.h"
#include "database.h"
#include "category.h"
#include "help.h"
#include "menu.h"

using namespace std;

void Database::setOpendFile(string s)
{
	OpendFile=s;
}

string Database::getOpendFile()
{
	return OpendFile;
}


void Database::lasafil(string fileToOpen) // Lser frn fil
{

  	string string_file;
	
	setOpendFile(fileToOpen);
	
	string confFile = getOpendFile()+".cat";
	ifstream infil;
	infil.open(confFile.c_str());


	while (getline(infil,string_file))
	{
		cat.addCategory(string_file);
	}
	
	infil.close();
	
	
	
	string string_file2;
	string dataFile = getOpendFile()+".txt";
	ifstream infil2;
	infil2.open(dataFile.c_str());

	while (getline(infil2,string_file2))
	{
		dat.addData(string_file2);
	}
		infil2.close();
}		
	

Database::~Database() // sparar vid avslut
{
	
	
		 	ofstream utfil;
		 	string s = getOpendFile()+".cat";
			utfil.open (s.c_str());
			
	
	for (int i=0;i<cat.sizeCategory();i++)
	{
    
   		utfil << cat.getCategory(i) << endl;
  }
  
  		utfil.close();
  		
  		ofstream utfil2;
		  string s2 = getOpendFile()+".txt";
			utfil2.open (s2.c_str());
			
	
	for (int i=0;i<dat.sizeData();i++)
	{
    
   		utfil2 << dat.getData(i) << endl;
  }
	utfil2.close();
	
}

int Database::getCorrespondingCategory(int datapost) // hittar rtt kategori till datan
{

	
		return  (datapost % cat.sizeCategory());

	
	
}


void Database::deleteCorrData(int i)
{	
	while (i<dat.sizeData())
	{	
		dat.deleteData(i);
		i += cat.sizeCategory();
	}
	
}

vector<int>* Database::seek(int search_int,string search_str, bool exact_match) // returnerar en int vektor med de funna matchningarna
{
	vector<int> *hittat = new vector<int>;

	if (search_int>=cat.sizeCategory())
	{
		for (int i=0;i<dat.sizeData();i++)
		{


				if (exact_match==true)
				{


						if (search_str==dat.getData(i))
									hittat->push_back(i);
				}
					
		
				else
				{


						if (dat.getData(i).find(search_str) != string::npos)
									hittat->push_back(i);

						
						
						
						
				}

		}
	
	}
	else
	{
		
		
		for (int i=0;i<dat.sizeData();i++)
		{
			int current_cattegory = getCorrespondingCategory(search_int);
			if (current_cattegory == getCorrespondingCategory(i))
			{
				if (exact_match==true)
				{
				if (search_str==dat.getData(i))
					hittat->push_back(i);
				}
				else
				{
					if (dat.getData(i).find(search_str) != string::npos)
						hittat->push_back(i);
				}
			}		

		}
		
	}

	return hittat;

}


void Database::addCat(string s)
{
	
	cat.addCategory(s);
	int i = 0;
	while (i<dat.sizeData()) // Plats fr ny data i de nya kategorierna.
	{
		i=i+cat.sizeCategory();
		dat.insertData(i);
	}
	
}
